#ifndef HELLO_VIEW_H
#include "view.h"
#endif
#include <GraphicsDefs.h>
#include <stdio.h>
#include <Application.h>
		
#define ROUND(a)    ( (long)(a+.5) )

rgb_color blue={0,0,0xff,0};
static BPoint p1,p2,p3,p4; 
void HelloView::plot4(int x,int y,int xo,int yo, float ratio) {
	static int oldX,oldY;
	if (x==0)  { 
		oldX=0;
		oldY=y;
		}
	BeginLineArray(5);
	AddLine(BPoint(xo+oldX*ratio,yo+oldY),BPoint(xo+x*ratio,yo+y),blue) ;
	AddLine(BPoint(xo-oldX*ratio,yo+oldY),BPoint(xo-x*ratio,yo+y),blue) ;
	AddLine(BPoint(xo+oldX*ratio,yo-oldY),BPoint(xo+x*ratio,yo-y),blue) ;
	AddLine(BPoint(xo-oldX*ratio,yo-oldY),BPoint(xo-x*ratio,yo-y),blue) ;
	EndLineArray();
	oldX=x;
	oldY=y;	
}

void HelloView::circle3(const BRect &r) {
	StrokeEllipse(r);
}

void HelloView::circle1(const BRect &r) {
	float xc = (r.left+r.right)/2;
	float yc = (r.top+r.bottom)/2;
	float rx = r.Width()/2;
	float ry = r.Height()/2;
	int Rx2 = ROUND(rx*rx);
	int Ry2 = ROUND(ry*ry);
	int twoRx2 = 2*Rx2;
	int twoRy2 = 2*Ry2;
	int p;
	int x=0;
	int y = (int)ry;
	int px = 0;
	int py = twoRx2 * y;

	plot4(x,y,xc,yc,1);

	p = ROUND (Ry2 - (Rx2 * ry) + (.25 * Rx2));
	while (px < py)
	{
		x++;
		px += twoRy2;
		if ( p < 0 )
			p += Ry2 + px;
		else
		{
			y--;
			py -= twoRx2;
			p += Ry2 + px - py;
		}

		plot4(x,y,xc,yc,1);
	}

	p = ROUND(Ry2*(x+.5)*(x+.5) + Rx2*(y-1)*(y-1) - Rx2*Ry2);
	while (y>0)
	{
		y--;
		py -= twoRx2;
		if (p>0)
			p += Rx2 - py;
		else
		{
			x++;
			px += twoRy2;
			p += Rx2 - py +px;
		}

		plot4(x,y,xc,yc,1);
	}
}

void HelloView::circle2(int xo,int yo,int radius,float ratio) {
	int y=radius, diff=0;
	for (int x=0;x<=radius;x++) {
		diff+=(x<<1)+1;
		while (diff>((y<<1)+1)) 
			diff-=((y--<<1)+1);
		plot4(x,y,xo,yo,ratio);
	}	
}

HelloView::HelloView(BRect rect, const char *name, const char *text)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW|B_FRAME_EVENTS|B_FULL_UPDATE_ON_RESIZE | B_SUBPIXEL_PRECISE )
{
}

void HelloView::Draw(BRect updateRect) {
	SetViewColor(100,60,60,255);
	SetLowColor(200,0,200,255);
	SetHighColor(200,0,200,255);
	for (int i=10;i<=90;i+=10) {
		float e=i/45.0;
		circle1(BRect(	200-i*e, 200-i, 200+i*e, 200+i ));
		circle3(BRect(	200-i*e, 200-i, 200+i*e, 200+i ));
		circle2(200,200,i,e);
		}
	printf ("Done!\n");
}
